﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="CaptchaHelper.cs" company="Eyal Shilony">
// 	© 2012 Eyal Shilony, All rights reserved.
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace EasyFront.Web.Desktop
{
	using System;
	using System.Diagnostics.Contracts;
	using System.Linq.Expressions;
	using System.Web;
	using System.Web.Mvc;

	using EasyFront.Core.Web.Mvc;
	using EasyFront.Core.Web.Security.Authentication;

	public static class CaptchaHelper
	{
		private static readonly CaptchaManager CaptchaManager;

		static CaptchaHelper()
		{
			CaptchaManager = new CaptchaManager(new CaptchaConfiguration());
		}

		public static IHtmlString CaptchaImage(this HtmlHelper helper, int width = 0, int height = 0)
		{
			Contract.Requires(helper != null);
			Contract.Requires(width >= 0);
			Contract.Requires(height >= 0);

			return CaptchaManager.CreateImage(helper, width, height);
		}

		public static IHtmlString CaptchaTextBoxFor<TModel, TProperty>(this HtmlHelper<TModel> helper, Expression<Func<TModel, TProperty>> expression)
		{
			Contract.Requires(helper != null);
			Contract.Requires(expression != null);

			return CaptchaManager.CreateTextBoxFor(helper, expression);
		}
	}
}